#ifndef _DEV_EPUB_H_
#define _DEV_EPUB_H_

#include "fitz.h"
#include "dev_epub.h"
#include "contrib\minizip\zip.h"

#ifndef NDEBUG
#define DO(E,S) do { if (E == 0) {E=(S);} else fprintf(stderr, "error carried in at %s:%d\n", __FILE__, __LINE__);} while(0==1)
#else
#define DO(E,S) do { if (E == 0) {E=(S);} } while(0==1)
#endif
#define PRINT2ZIP(E,S) zipWriteInFileInZip(E->outzip, S, strlen(S))

typedef struct fz_epubstyle_s fz_epubstyle;
typedef struct fz_epubstyles_s fz_epubstyles;

struct fz_epub_s
{
	zipFile        outzip;
	int            chapterOpen;
	int            chapterCount;
	int            pageCount;
	fz_epubstyles *styles;
};

typedef struct fz_epubdevice_s fz_epubdevice;

fz_device *
fz_newepubdevice(fz_epub *epub);

fz_epubstyle *fz_epub_findstyle(fz_epubstyles *styles, fz_text *text, fz_matrix *ctm, fz_colorspace *colorspace, float *color, float alpha, fz_strokestate *stroke);

fz_epubstyles *fz_epubstyles_create(void);

int fz_epubstyles_writestylesheet(fz_epub *epub);

void fz_epubstyles_destroy(fz_epubstyles *styles);

#endif /* _DEV_EPUB_H_ */
